from StringIO import StringIO

from Products.CMFCore.utils import getToolByName
from Products.CMFCore.permissions import ManagePortal
from Products.Archetypes.Extensions.utils import install_subskin

from Products.PrivacyRegistrationTool import RegistrationTool
from Products.PrivacyRegistrationTool import privacy_globals

_globals = globals()

def install_tools(self, out):

    tool_name = 'portal_registration'

    tool = getToolByName(self, tool_name, None)
    if tool:
        self.manage_delObjects(ids=[tool_name])
        print >> out, 'Removed previous registration tool.'

    addTool = self.manage_addProduct['PrivacyRegistrationTool'].manage_addTool
    addTool('Privacy Registration Tool')

    tool = getToolByName(self, tool_name)
    tool.title = 'Handles registration of new users and membership of old users'

    print >> out, 'Added privacy registration tool.'


def setup_member_properties(self, out):
    pm = getToolByName(self, 'portal_memberdata')
    pm._setProperty('enabled', False, 'boolean')
    pm._setProperty('last_password_change', '2000/01/01', 'date')
    pm._setProperty('password_attempts', 0, 'int')
    pm._setProperty('last_passwords', [], 'lines')

def install(self):
    out = StringIO()

    print >>out, 'Installing Privacy Registration Tool'

    install_tools(self, out)
    install_subskin(self, out, privacy_globals)
    setup_member_properties(self, out)

    return out.getvalue()