"""
30 18 * * * /usr/local/bin/python /home/mediatria/daily_jobs/newsletter_job.py
"""
import sys
import string, xmlrpclib, httplib
from base64 import encodestring

class BasicAuthTransport(xmlrpclib.Transport):

   def __init__(self, username=None, password=None):
       self.username=username
       self.password=password

   def request(self, host, handler, request_body, verbose):
       # issue XML-RPC request

       self.verbose = verbose

       h = httplib.HTTP(host)
       h.putrequest("POST", handler)

       # required by HTTP/1.1
       h.putheader("Host", host)

       # required by XML-RPC
       h.putheader("User-Agent", self.user_agent)
       h.putheader("Content-Type", "text/xml")
       h.putheader("Content-Length", str(len(request_body)))

       # basic auth
       if self.username is not None and self.password is not None:
          h.putheader("AUTHORIZATION", "Basic %s" % string.replace(encodestring("%s:%s" % \
              (self.username, self.password)),"\012", ""))
       h.endheaders()

       if request_body:
          h.send(request_body)

       errcode, errmsg, headers = h.getreply()

       if errcode != 200:
          raise xmlrpclib.ProtocolError(host + handler, errcode, errmsg, headers)
       return self.parse_response(h.getfile())


if __name__=="__main__":

    if len(sys.argv)<3:
        raise 'incorrect number of arguments, you need: user passwd portal_url'

    user = sys.argv[1]
    passwd= sys.argv[2]
    host = sys.argv[3]

    url = host+"/portal_registration"
    root = xmlrpclib.Server(url, BasicAuthTransport(user, passwd))
    root.resetPassword()
    # the method can take a list of ids
    # root.resetPassword(['axa','vds',])
